<template>
  <div>
    <v-dialog
      v-model="isLoading"
      hide-overlay
      persistent
      width="500"
    >
      <v-card
        color="primary"
        dark
      >
        <v-card-text>
          Vérification de l'email en cours ...
          <v-progress-linear
            indeterminate
            color="white"
            class="mb-0"
          ></v-progress-linear>
        </v-card-text>
      </v-card>
    </v-dialog>

    <v-dialog v-model="dialog" persistent max-width="500">
      <NewPasswordForm/>
    </v-dialog>
  </div>
</template>

<script>
import { mapFields } from 'vuex-map-fields';
import { mapActions, mapGetters } from 'vuex';
import NotificationMixin from '../../mixins/NotificationMixin';
import NewPasswordForm from '../../components/user/newPassword';
export default {
  name: 'VerifyEmailView',
  mixins: [NotificationMixin],
  components: {
    NewPasswordForm
  },
  data() {
    return {
      token : '',
      dialog: false
    }
  },

  created() {
    if (this.verified) {
      this.$router.push({name:'login'});
      this.showMessage('Compte vérifié! Vous pouvez vous connecter' , 'success')
    } else if(this.$route.params.token && !this.loggedIn) {
      this.token = this.$route.params.token;
      this.verifyEmail(this.token);
    } else {
      this.$router.push({name:'home'});
    }
  },
  computed: {
    ...mapFields('user', [ 'loggedIn','userInfos', 'verified','error', 'isLoading']),
    ...mapGetters('user', ['getRoles'])
  },
  methods: {
    ...mapActions('user', ['verifyEmail'])
  },
  watch: {
    verified(newVerified) {
      if (newVerified) {
        if (this.getRoles.includes('ROLE_COMPANY')) {
          this.dialog = true;
          this.showMessage('Veuillez définir votre mot de passe ! ' , 'warning');
        } else {
          this.$router.push({name:'login'});
          this.showMessage('Compte vérifié! Vous pouvez vous connecter' , 'success');
        }
      }
    },
    error(newError) {
      if (newError && newError === 'Already verified') {
        this.$router.push({name:'login'});
        this.showMessage('Votre compte est déjà vérifié' , 'warning');
      }
    }
  },

};
</script>
